% generates the header file for electric etch project. Run drawing.m first

%% Generate actual chars if available

names = cell(1,127);

for i = 0:127
    % apply special case names here
    tail = char(i);
    if char(i) == ' '
        tail = '_space';
    elseif char(i) == ':'
        tail = '_col';
    elseif char(i) == ','
        tail = '_comma';
    elseif char(i) == '.'
        tail = '_dot';
    elseif char(i) == '!'
        tail = '_emark';
    elseif char(i) == '?'
        tail = '_qmark';
    elseif char(i) == '/'
        tail = '_slash';
    end
    
    varname = sprintf('coord%s',tail);  
    
    try
       number = eval(varname);
     catch FAIL
        continue
    end
    
    fprintf('const int16_t c_%s_P[] PROGMEM =\n', tail)
    [r c] = size(number);
    fprintf('{\n\t%i,\n',r)
    for i = 1:r 
       if i==r
           s = '';
       else
           s = ',';
       end
       fprintf('\t%i,\t\t%i%s\n',number(i,1), number(i,2), s)
    end
    fprintf('};\n');


end




%% Generate ascii table
fprintf('PGM_P ascii_table[] PROGMEM =\n{\n')

for i = 0:127
    pointer_name = '0';
    
    coord_name = char(i);

    if char(i) == ' '
        coord_name = '_space';
    elseif char(i) == ':'
        coord_name = '_col';
    elseif char(i) == ','
        coord_name = '_comma';
    elseif char(i) == '.'
        coord_name = '_dot';
    elseif char(i) == '!'
        coord_name = '_emark';
    elseif char(i) == '?'
        coord_name = '_qmark';
    elseif char(i) == '/'
        coord_name = '_slash';
    end
    
    try
        junk = eval(sprintf('coord%s',coord_name));
        pointer_name = sprintf('(int*) c_%s_P',coord_name);
    end
    
    fprintf('\t%s',pointer_name);
    
    if i ~= 127
        fprintf(',')
    end
    
    if i>=32 && i<=126
        comment1 = ['''', char(i), ''''];
    else
        comment1 = '(control)';
    end
        
    if pointer_name == '0'
        comment2 = ' (undefined)';
    else
        comment2 = '';
    end
    
    fprintf('\t// %i: %s %s\n',i, comment1, comment2)
   
end

fprintf('};\n')
